/* Mesquite source code.  Copyright 1997-2004 W. Maddison and D. Maddison. 
Version 1.01, January 2004.
Disclaimer:  The Mesquite source code is lengthy and we are few.  There are no doubt inefficiencies and goofs in this code. 
The commenting leaves much to be desired. Please approach this source code with the spirit of helping out.
Perhaps with your help we can be more than a few, and make Mesquite better.

Mesquite is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY.
Mesquite's web site is http://mesquiteproject.org

This source code and its compiled class files are free and modifiable under the terms of 
GNU Lesser General Public License.  (http://www.gnu.org/copyleft/lesser.html)
*/
package mesquite.basic.AssignTaxonNames;

import java.util.*;
import java.awt.*;
import java.text.Collator;
import mesquite.lib.*;
import mesquite.lib.duties.*;
import mesquite.lib.table.*;

/* ======================================================================== */
public class AssignTaxonNames extends TaxonNameAlterer {
	String prefix = "taxon ";
	/*.................................................................................................................*/
	public boolean startJob(String arguments, Object condition, CommandRecord commandRec, boolean hiredByName){
		return true;
	}
	/*.................................................................................................................*/
	public boolean getOptions(CommandRecord commandRec){
		if (commandRec.scripting())
			return true;
		String p = MesquiteString.queryString(containerOfModule(), "Assign taxon names", "Assign taxon names beginning with the following string, and followed by the taxon number", prefix);
		if (p == null)
			return false;
		prefix = p;
		return true;
			
	}
	/*.................................................................................................................*/
   	/** Called to alter the taxon name in a single cell.  If you use the alterContentOfCells method of this class, 
   	then you must supply a real method for this, not just this stub. */
   	public boolean alterName(Taxa taxa, int it, CommandRecord commandRec){
		taxa.setTaxonName(it, prefix + (it+1), false);
		return true;
   	}
	/*.................................................................................................................*/
    	 public String getNameForMenuItem() {
		return "Assign taxon names...";
   	 }
	/*.................................................................................................................*/
    	 public String getName() {
		return "Assign taxon names";
   	 }
   	 
	/*.................................................................................................................*/
  	 public String getExplanation() {
		return "Assigns to each taxon name a string followed by a number.  For example, if the string is \"g\", then taxon 3 will be assigned the name g3.";
   	 }
}


	

