/* Mesquite source code.  Copyright 1997-2004 W. Maddison and D. Maddison. 
Version 1.01, January 2004.
Disclaimer:  The Mesquite source code is lengthy and we are few.  There are no doubt inefficiencies and goofs in this code. 
The commenting leaves much to be desired. Please approach this source code with the spirit of helping out.
Perhaps with your help we can be more than a few, and make Mesquite better.

Mesquite is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY.
Mesquite's web site is http://mesquiteproject.org

This source code and its compiled class files are free and modifiable under the terms of 
GNU Lesser General Public License.  (http://www.gnu.org/copyleft/lesser.html)
*/
package mesquite.charMatrices.ColorByFootnote; 

import java.util.*;
import java.awt.*;
import mesquite.lib.*;
import mesquite.lib.characters.*;
import mesquite.lib.duties.*;
import mesquite.lib.table.*;


/* ======================================================================== */
public class ColorByFootnote extends DataWindowAssistantI implements CellColorer {
	MesquiteTable table;
	CharacterData data;
	/*.................................................................................................................*/
	public boolean startJob(String arguments, Object condition, CommandRecord commandRec, boolean hiredByName){
		return true;
	}
	/*.................................................................................................................*/
   	 public boolean isSubstantive(){
   	 	return false;
   	 }
	/*.................................................................................................................*/
	public void setTableAndData(MesquiteTable table, CharacterData data, CommandRecord commandRec){
		this.table = table;
		this.data = data;
	}
	/*.................................................................................................................*/
    	 public String getName() {
		return "Color By Footnote";
   	 }
	/*.................................................................................................................*/
  	 public String getExplanation() {
		return "Colors the cells of a character matrix by whether or not they have a footnote.";
   	 }
   	 
   	 public void setActiveColors(boolean active, CommandRecord commandRec){
   	 }
	public Color getCellColor(int ic, int it){
		if (data == null || data.getAnnotation(ic, it) ==null)
			return Color.white;
		else {
			return ColorDistribution.lightGreen;
		}
	}
	public CompatibilityTest getCompatibilityTest(){
		return new CharacterStateTest();
	}
}


	

