/* Mesquite source code.  Copyright 1997-2004 W. Maddison and D. Maddison. 
Version 1.01, January 2004.
Disclaimer:  The Mesquite source code is lengthy and we are few.  There are no doubt inefficiencies and goofs in this code. 
The commenting leaves much to be desired. Please approach this source code with the spirit of helping out.
Perhaps with your help we can be more than a few, and make Mesquite better.

Mesquite is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY.
Mesquite's web site is http://mesquiteproject.org

This source code and its compiled class files are free and modifiable under the terms of 
GNU Lesser General Public License.  (http://www.gnu.org/copyleft/lesser.html)
*/
package mesquite.distance.lib;

import java.awt.*;
import java.util.*;
import mesquite.lib.duties.*;
import mesquite.lib.*;


/* ======================================================================== */
/** A distance matrix for taxa.*/
public abstract class TaxaDistance {
	Taxa taxa;
	public TaxaDistance(Taxa taxa){
		this.taxa = taxa;
	}
	public Taxa getTaxa(){
		return taxa;
	}
	public int getNumTaxa(){
		if (taxa==null)
			return 0;
		else
			return taxa.getNumTaxa();
	}
	public abstract double getDistance(int taxon1, int taxon2);
	public abstract double[][] getMatrix();
	public abstract boolean isSymmetrical();
}


