/* Mesquite source code.  Copyright 2001-2004 D. Maddison and W. Maddison. 
Version 1.01, January 2004.
Disclaimer:  The Mesquite source code is lengthy and we are few.  There are no doubt inefficiencies and goofs in this code. 
The commenting leaves much to be desired. Please approach this source code with the spirit of helping out.
Perhaps with your help we can be more than a few, and make Mesquite better.

Mesquite is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY.
Mesquite's web site is http://mesquiteproject.org

This source code and its compiled class files are free and modifiable under the terms of 
GNU Lesser General Public License.  (http://www.gnu.org/copyleft/lesser.html)
*/
package mesquite.lib;

import java.awt.*;



/*===============================================*/
/** a field for doubles */
public class DoubleField  {
	ExtensibleDialog dialog;
	SingleLineTextField textField;
	double initialValue=MesquiteDouble.unassigned;
	/*.................................................................................................................*/
	public DoubleField (ExtensibleDialog dialog, String message, double initialValue, int fieldLength) {
		super();
		this.dialog = dialog;
		this.initialValue = initialValue;
		if (initialValue==MesquiteDouble.unassigned)
			textField = dialog.addTextField (message, "", fieldLength);
		else
			textField = dialog.addTextField (message, MesquiteDouble.toString(initialValue), fieldLength);
	}
	/*.................................................................................................................*/
	public DoubleField (ExtensibleDialog dialog, String message, int fieldLength) {
		super();
		this.dialog = dialog;
		this.initialValue = 0.0;
		textField = dialog.addTextField (message, "", fieldLength);
	}

	/*.................................................................................................................*/
	public double getValue () {
		String s = textField.getText();
		double value = MesquiteDouble.fromString(s);
		if (!MesquiteDouble.isCombinable(value)) {
			value=initialValue;
		}
	        return value;
	}
	/*.................................................................................................................*/
	public void setValue (double value) {
		textField.setText(MesquiteDouble.toString(value));
	}

}
