/* Mesquite source code.  Copyright 1997-2004 W. Maddison and D. Maddison. 
Version 1.01, January 2004.
Disclaimer:  The Mesquite source code is lengthy and we are few.  There are no doubt inefficiencies and goofs in this code. 
The commenting leaves much to be desired. Please approach this source code with the spirit of helping out.
Perhaps with your help we can be more than a few, and make Mesquite better.

Mesquite is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY.
Mesquite's web site is http://mesquiteproject.org

This source code and its compiled class files are free and modifiable under the terms of 
GNU Lesser General Public License.  (http://www.gnu.org/copyleft/lesser.html)
*/

package mesquite.lib;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import mesquite.lib.duties.*;


/* ======================================================================== */
/** The window that displays the log. */
public class LogWindow extends ConsoleWindow {
	boolean keyHasBeenDown = false;
	public LogWindow() {
		super(MesquiteModule.mesquiteTrunk, "Mesquite Log"); //infobar
		
		setBackground(Color.white);
	}
	
	/** Returns menu location for item to bring the window to the for (0 = custom or don't show; 1 = system area of Windows menu; 2 = after system area of Windows menu)*/
	public int getShowMenuLocation(){
		return 1;
	}
	
	public boolean keyDown(){
		return keyHasBeenDown;
	}
	public void keyTyped(KeyEvent e){
		keyHasBeenDown = true;
		super.keyTyped(e);
	}
	
	public void keyPressed(KeyEvent e){
		keyHasBeenDown = true;
		super.keyPressed(e);
	}
	
	public void keyReleased(KeyEvent e){
		super.keyReleased(e);
	}
}
