/* Mesquite source code.  Copyright 1997-2004 W. Maddison and D. Maddison. 
Version 1.01, January 2004.
Disclaimer:  The Mesquite source code is lengthy and we are few.  There are no doubt inefficiencies and goofs in this code. 
The commenting leaves much to be desired. Please approach this source code with the spirit of helping out.
Perhaps with your help we can be more than a few, and make Mesquite better.

Mesquite is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY.
Mesquite's web site is http://mesquiteproject.org

This source code and its compiled class files are free and modifiable under the terms of 
GNU Lesser General Public License.  (http://www.gnu.org/copyleft/lesser.html)
*/
package mesquite.lib.duties;

import java.awt.*;
import mesquite.lib.*;
import mesquite.lib.characters.*;


/* ======================================================================== */
/**Assigns states to nodes of tree for a character.
Example modules:  ParsAncestralStates, MaxPosteriorJoint, MLEAncestralStates.*/

public abstract class CharStatesForNodes extends MesquiteModule  {
	/*public static final int version = 2;
	public int oldNumTaxa = 0;
	public CharacterHistory statesAtNodes;  //TODO: don't rely on public !  have getCharacterHistory method!!!
	public int ic=0;
*/
   	 public Class getDutyClass() {
   	 	return CharStatesForNodes.class;
   	 }
 	public String getDutyName() {
 		return "Assign states of character to nodes";
   	 }
   	 public String[] getDefaultModule() {
 		return new String[] {"#ParsAncestralStates"};
   	 }
   	
	public abstract void calculateStates(Tree tree, CharacterDistribution charStates, CharacterHistory resultStates, MesquiteString resultString, CommandRecord commandRec); //commandRec added 21 Mar 02
	
	/** sets whether or not module will be requested to do one character at a time; if so, then it might know to put up menu items
	to change the model of the character, or adjust it in some other way*/
   	public void setOneCharacterAtATime(boolean chgbl){}
   	
   	
	public abstract boolean allowsStateWeightChoice();
}


