/* Mesquite source code.  Copyright 1997-2004 W. Maddison and D. Maddison. 
Version 1.01, January 2004.
Disclaimer:  The Mesquite source code is lengthy and we are few.  There are no doubt inefficiencies and goofs in this code. 
The commenting leaves much to be desired. Please approach this source code with the spirit of helping out.
Perhaps with your help we can be more than a few, and make Mesquite better.

Mesquite is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY.
Mesquite's web site is http://mesquiteproject.org

This source code and its compiled class files are free and modifiable under the terms of 
GNU Lesser General Public License.  (http://www.gnu.org/copyleft/lesser.html)
*/
package mesquite.lib.duties;

import java.awt.*;
import mesquite.lib.*;
import mesquite.lib.characters.*;


/* ======================================================================== */
/** Coordinates managers of character data matrices. Relies on CharMatrixManagers for the details of
each data type.  Example module: "Manage CHARACTERS blocks" (class ManageCharacters)*/

public abstract class CharactersManager extends FileElementManager   {

   	 public Class getDutyClass() {
   	 	return CharactersManager.class;
   	 }
 	public String getDutyName() {
 		return "Coordinator of managers of character data matrices";
   	 }
	/** create new CharacterData object with data type indicated by passed string.  String is *not* NEXUS keyword
	for data type, but rather the descriptive phrase returned by the CharMatrixManagers' getDataClassName methods.*/
	public abstract CharacterData newCharacterData(Taxa taxa, int numChars, String dataType);
	
	public abstract String[] dataClassesAvailable();
	
	public abstract CharacterData processFormat(MesquiteFile file, Taxa taxa, String formatCommand, int numChars);
	
	/**Returns the module that reads and writes matrices of a particular subclass*/
	public abstract CharMatrixManager getMatrixManager(Class dataClass);

	public Class getElementClass(){
		return CharacterData.class;
	}
 	public abstract MesquiteSubmenuSpec getListsSubmenu();
}

