/* Mesquite source code.  Copyright 1997-2004 W. Maddison and D. Maddison. 
Version 1.01, January 2004.
Disclaimer:  The Mesquite source code is lengthy and we are few.  There are no doubt inefficiencies and goofs in this code. 
The commenting leaves much to be desired. Please approach this source code with the spirit of helping out.
Perhaps with your help we can be more than a few, and make Mesquite better.

Mesquite is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY.
Mesquite's web site is http://mesquiteproject.org

This source code and its compiled class files are free and modifiable under the terms of 
GNU Lesser General Public License.  (http://www.gnu.org/copyleft/lesser.html)
*/
package mesquite.lib.duties;

import java.awt.*;
import mesquite.lib.*;




/* ======================================================================== */
/**Supplies a number for two taxa, e.g. the distance between them.*/

public abstract class NumberFor2Taxa extends MesquiteModule  {

   	 public Class getDutyClass() {
   	 	return NumberFor2Taxa.class;
   	 }
 	public String getDutyName() {
 		return "Number for Two Taxa";
   	 }
   	/** Called to provoke any necessary initialization.  This helps prevent the module's intialization queries to the user from
   	happening at inopportune times (e.g., while a long chart calculation is in mid-progress)*/
   	public abstract void initialize(Taxon t1, Taxon t2, CommandRecord commandRec);
   	
	public abstract void calculateNumber(Taxon t1, Taxon t2, MesquiteNumber result, MesquiteString resultString, CommandRecord commandRec);
	
}

