/* Mesquite source code.  Copyright 1997-2004 W. Maddison and D. Maddison. 
Version 1.01, January 2004.
Disclaimer:  The Mesquite source code is lengthy and we are few.  There are no doubt inefficiencies and goofs in this code. 
The commenting leaves much to be desired. Please approach this source code with the spirit of helping out.
Perhaps with your help we can be more than a few, and make Mesquite better.

Mesquite is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY.
Mesquite's web site is http://mesquiteproject.org

This source code and its compiled class files are free and modifiable under the terms of 
GNU Lesser General Public License.  (http://www.gnu.org/copyleft/lesser.html)
*/
package mesquite.lib.duties;

import java.awt.*;
import mesquite.lib.*;


/* ======================================================================== */
/** Manages sets of taxa.  Also reads and writes TAXA NEXUS block.  Example module:
"Manage TAXA blocks" (class ManageTaxa)*/

public abstract class TaxaManager extends FileElementManager   {

   	 public Class getDutyClass() {
   	 	return TaxaManager.class;
   	 }
 	public String getDutyName() {
 		return "Manager of sets of taxa, including read/write TAXA block";
   	 }
	
   	public boolean isSubstantive(){
   		return false;  
   	}
	/*.................................................................................................................*/
	/** make new Taxa object with given name and number of taxa*/
	public abstract Taxa makeNewTaxa(String name, int numTaxa, boolean userQuery);
	public Class getElementClass(){
		return Taxa.class;
	}
	public abstract String getTaxaBlock(Taxa taxa, TaxaBlock tB);
}

