/* Mesquite (package mesquite.lists).  Copyright 1997-2004 W. Maddison and D. Maddison. 
Version 1.01, January 2004.
Disclaimer:  The Mesquite source code is lengthy and we are few.  There are no doubt inefficiencies and goofs in this code. 
The commenting leaves much to be desired. Please approach this source code with the spirit of helping out.
Perhaps with your help we can be more than a few, and make Mesquite better.

Mesquite is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY.
Mesquite's web site is http://mesquiteproject.org

This source code and its compiled class files are free and modifiable under the terms of 
GNU Lesser General Public License.  (http://www.gnu.org/copyleft/lesser.html)
*/
package mesquite.lists.CharInclSetListNum;
/*~~  */

import mesquite.lists.lib.*;
import java.util.*;
import java.awt.*;
import mesquite.lib.*;
import mesquite.lib.characters.*;
import mesquite.lib.duties.*;
import mesquite.lib.table.*;

/* ======================================================================== */
public class CharInclSetListNum extends CharInclSetListAsst implements MesquiteListener {
	CharacterData data=null;
	/*.................................................................................................................*/
	public boolean startJob(String arguments, Object condition, CommandRecord commandRec, boolean hiredByName) {
		/* hire employees here */
		return true;
  	 }
  	 
	public void setTableAndObject(MesquiteTable table, Object obj, CommandRecord commandRec){
		if (data !=null)
			data.removeListener(this);
		if (obj instanceof CharacterData)
			data = (CharacterData)obj;
		if (data !=null)
			data.addListener(this);
		//table would be used if selection needed
	}
	/*.................................................................................................................*/
	/** passes which object is being disposed (from MesquiteListener interface)*/
	public void disposing(Object obj){
		//TODO: respond
	}
	/*.................................................................................................................*/
	/** passes which object is being disposed (from MesquiteListener interface)*/
	public boolean okToDispose(Object obj, int queryUser){
		return true;  //TODO: respond
	}
	public void changed(Object caller, Object obj, Notification notification, CommandRecord commandRec){
		if (Notification.appearsCosmetic(notification))
			return;
		parametersChanged(null, commandRec);
	}
	public String getTitle() {
		return "# chars. included";
	}
	public String getStringForRow(int ic){
		try{
		if (data == null)
			return null;
		SpecsSetVector tsets = data.getSpecSetsVector(CharInclusionSet.class);
		if (tsets ==null || ic<0 || ic>= tsets.size())
			return "";
		return Integer.toString(((CharInclusionSet)tsets.elementAt(ic)).numberSelected());
		}
		catch (NullPointerException e){
		}
		return "";
	}
	public String getWidestString(){
		return " # chars. included ";
	}
	/*.................................................................................................................*/
    	 public String getName() {
		return "Number of characters in inclusion set";
   	 }
	/*.................................................................................................................*/
   	public boolean isPrerelease(){
   		return false;  
   	}
   	 
	/*.................................................................................................................*/
 	/** returns an explanation of what the module does.*/
 	public String getExplanation() {
 		return "Indicates number of characters in inclusion set in list window." ;
   	 }
   	 public void endJob() {
		if (data !=null)
			data.removeListener(this);
		super.endJob();
   	 }
   	 
}
