/* Mesquite (package mesquite.lists).  Copyright 1997-2004 W. Maddison and D. Maddison. 
Version 1.01, January 2004.
Disclaimer:  The Mesquite source code is lengthy and we are few.  There are no doubt inefficiencies and goofs in this code. 
The commenting leaves much to be desired. Please approach this source code with the spirit of helping out.
Perhaps with your help we can be more than a few, and make Mesquite better.

Mesquite is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY.
Mesquite's web site is http://mesquiteproject.org

This source code and its compiled class files are free and modifiable under the terms of 
GNU Lesser General Public License.  (http://www.gnu.org/copyleft/lesser.html)
*/
package mesquite.lists.CharSetList;
/*~~  */

import mesquite.lists.lib.*;
import java.util.*;
import java.awt.*;
import mesquite.lib.*;
import mesquite.lib.characters.*;
import mesquite.lib.duties.*;
import mesquite.lib.table.*;

/* ======================================================================== */
public class CharSetList extends DataSpecssetList {
	public int currentDataSet = 0;
	public CharacterData data = null;
	DataSpecsListWindow window;
	/*.................................................................................................................*/
	public boolean startJob(String arguments, Object condition, CommandRecord commandRec, boolean hiredByName) {
		makeMenu("List");
		addMenuItem("Make New Character Set...", makeCommand("newCharSet",  this));
		return true;
  	 }
	/** returns a String of annotation for a row*/
	public String getAnnotation(int row){ return null;}

	/** sets the annotation for a row*/
	public void setAnnotation(int row, String s, boolean notify){}
	/*.................................................................................................................*/
  	 public void showListWindow(Object obj, CommandRecord commandRec){ ///TODO: change name to makeLIstWindow
		super.showListWindow(obj, commandRec);
		CharSetListAsst assistant = (CharSetListAsst)hireNamedEmployee(commandRec, CharSetListAsst.class, "#CharSetListNum");
 		if (assistant!= null){
 			((ListWindow)getModuleWindow()).addListAssistant(assistant, commandRec);
			assistant.setUseMenubar(false);
		}
  	 }
  	public boolean usesCurrentSet(){
  		return false;
  	}
	public Class getItemType(){
		return CharSelectionSet.class;
	}
	public String getItemTypeName(){
		return "Character set";
	}
	public String getItemTypeNamePlural(){
		return "Character sets";
	}
	public SpecsSet makeNewSpecsSet(CharacterData data){
		if (data!=null)
			return new CharSelectionSet("Untitled Character Set", data.getNumChars(), data);
		return null;
	}
	/*.................................................................................................................*/
    	 public Object doCommand(String commandName, String arguments, CommandRecord commandRec, CommandChecker checker) {
		if (checker.compare(this.getClass(), "Instructs user as how to make new character set (CHARSET)", null, commandName, "newCharSet")){
			Object obj = getMainObject();
			if (!(obj instanceof CharacterData))
				return null;
			CharacterData data = (CharacterData)obj;
			if (data !=null &&AlertDialog.query(containerOfModule(), "New Character Set", "To make a new character set (CHARSET), go to the List of Characters window, select the characters you want to be part of the set, and choose Save Selected As Set.  Would you like to go to the List of Characters window now?", "OK", "Cancel")) {
				Object obj2 = data.doCommand("showMe", null, commandRec, checker);
			}
		}
    	 	else
    	 		return super.doCommand(commandName, arguments, commandRec, checker);
		return null;
   	 }
	/*.................................................................................................................*/
    	 public String getName() {
		return "List of Character Sets";
   	 }
   	 
	/*.................................................................................................................*/
   	 
 	/** returns an explanation of what the module does.*/
 	public String getExplanation() {
 		return "Makes windows listing character sets." ;
   	 }
	/*.................................................................................................................*/
}

