/* Mesquite (package mesquite.lists).  Copyright 1997-2004 W. Maddison and D. Maddison. 
Version 1.01, January 2004.
Disclaimer:  The Mesquite source code is lengthy and we are few.  There are no doubt inefficiencies and goofs in this code. 
The commenting leaves much to be desired. Please approach this source code with the spirit of helping out.
Perhaps with your help we can be more than a few, and make Mesquite better.

Mesquite is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY.
Mesquite's web site is http://mesquiteproject.org

This source code and its compiled class files are free and modifiable under the terms of 
GNU Lesser General Public License.  (http://www.gnu.org/copyleft/lesser.html)
*/
package mesquite.lists.ModelsListParadigm;
/*~~  */

import mesquite.lists.lib.*;
import java.util.*;
import java.awt.*;
import mesquite.lib.*;
import mesquite.lib.characters.*;
import mesquite.lib.duties.*;
import mesquite.lib.table.*;

/* ======================================================================== */
public class ModelsListParadigm extends ModelsListAssistant implements MesquiteListener {
	ListableVector models=null;
	/*.................................................................................................................*/
	public boolean startJob(String arguments, Object condition, CommandRecord commandRec, boolean hiredByName) {
		/* hire employees here */
		return true;
  	 }
  	 
	public void setTableAndObject(MesquiteTable table, Object obj, CommandRecord commandRec){
		if (models !=null)
			models.removeListener(this);
		if (obj instanceof ListableVector)
			models = (ListableVector)obj;
		models.addListener(this);
		//table would be used if selection needed
	}
	/*.................................................................................................................*/
	/** passes which object is being disposed (from MesquiteListener interface)*/
	public void disposing(Object obj){
		//TODO: respond
	}
	/*.................................................................................................................*/
	/** passes which object is being disposed (from MesquiteListener interface)*/
	public boolean okToDispose(Object obj, int queryUser){
		return true;  //TODO: respond
	}
	public void changed(Object caller, Object obj, Notification notification, CommandRecord commandRec){
		if (Notification.appearsCosmetic(notification))
			return;
		parametersChanged(notification, commandRec);
	}
	public String getTitle() {
		return "Paradigm";
	}
	public String getStringForRow(int ic){
		try{
		if (models ==null || ic<0 || ic> models.size())
			return "";
		return ((CharacterModel)models.elementAt(ic)).getParadigm();
		}
		catch (NullPointerException e){}
		return "";
		
	}
	public String getWidestString(){
		return "ProbabilityProbability";
	}
	/*.................................................................................................................*/
    	 public String getName() {
		return "Model Paradigm";
   	 }
	/*.................................................................................................................*/
	/** returns whether this module is requesting to appear as a primary choice */
   	public boolean requestPrimaryChoice(){
   		return true;  
   	}
   	 
	/*.................................................................................................................*/
   	public boolean isPrerelease(){
   		return false;  
   	}
	/*.................................................................................................................*/
 	/** returns an explanation of what the module does.*/
 	public String getExplanation() {
 		return "Indicates paradigm of model in list window." ;
   	 }
   	 public void endJob() {
		if (models !=null)
			models.removeListener(this);
		super.endJob();
   	 }
   	 
}
