/* Mesquite (package mesquite.lists).  Copyright 1997-2004 W. Maddison and D. Maddison. 
Version 1.01, January 2004.
Disclaimer:  The Mesquite source code is lengthy and we are few.  There are no doubt inefficiencies and goofs in this code. 
The commenting leaves much to be desired. Please approach this source code with the spirit of helping out.
Perhaps with your help we can be more than a few, and make Mesquite better.

Mesquite is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY.
Mesquite's web site is http://mesquiteproject.org

This source code and its compiled class files are free and modifiable under the terms of 
GNU Lesser General Public License.  (http://www.gnu.org/copyleft/lesser.html)
*/
package mesquite.lists.lib;
/*~~  */

import java.util.*;
import java.awt.*;
import mesquite.lib.*;


public class GroupDialog extends ExtensibleDialog implements Colorable {
	ColorPickerPanel colors;
	Color color;
	TextField name;
	public GroupDialog(Frame f, String title, String groupName, Color initColor){
		super(f, title);
		color = initColor;
		
		colors = new ColorPickerPanel(this, initColor, 30);
		name = addTextField("Name:", groupName, 30);
		addNewDialogPanel(colors);
		
	}
	public void setColor(Color c){
		color = c;
	}
	
	public Color getColor(){
		return colors.getColor();
	}
	
	public String getName(){
		return name.getText();
	}
}

